-- CONSULTA DE RECEITAS DIRETAS DA TELA
select
    cast(nt.numdocumento as varchar(100)) as numero_nota,
    nt.dtentradasaida as data,
    cast(pes.nome as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(ni.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.descricao as varchar(50)) as nome_centro_custo_patrimonio,
    cast(sa.descricao as varchar(30)) as safra,
    cast(((ni.vrtotal / 100)*nia.percentual) as decimal(15,2)) as valor_apropriado,
    cast(nt.acrescimodesconto as decimal(15,3)) as Desconto_Acrescimo,
    cast(nt.complemento as varchar(250)) as complemento,
    cast(nt.observacao as varchar(250)) as observacao
from
    notaitem ni
    join nota nt on nt.cdnota = ni.cdnota
    join notaitemapro nia on nia.cdnotaitem = ni.cdnotaitem
    join produto pr on pr.cdproduto = ni.cdproduto
    join centrocusto cc on cc.cdcentrocusto = nia.cdcentrocusto
    join contagerencial cg on cg.cdcontagerencial = ni.cdcontagerencial
    join pessoa pes on pes.cdpessoa = nt.cdpessoa
    left join safra sa on sa.cdsafra = nia.cdsafra
where
    nt.tiponota = 'S'
    and ni.saidaimediata = '0'
    and ni.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)

UNION ALL

-- CONSULTA DE RECEITAS DE PRODUÇÃO
select
    cast('Estoque' as varchar(100))as numero_nota,
    mo.data as data,
    cast('Estoque' as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(mo.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.descricao as varchar(50)) as nome_centro_custo_patrimonio,
    cast(sa.descricao as varchar(30)) as safra,
    cast(mo.vrtotal as decimal(15,2)) as valor_apropriado,
    cast(null as decimal (15,3))as Desconto_Acrescimo,
    cast('' as varchar(250)) as complemento,
    cast('' as varchar(250)) as observacao
from
    movimentoestoque mo
    join produto pr on pr.cdproduto = mo.cdproduto
    join contagerencial cg on cg.cdcontagerencial = mo.cdcontagerencial
    join centrocusto cc on cc.cdcentrocusto = mo.cdcentrocusto
    left join safra sa on sa.cdsafra = mo.cdsafra
where
    mo.cdtipomovimentoestoque = 4 and
    mo.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)

UNION ALL

-- CONSULTA DE CUSTOS A PARTIR DAS SAÍDAS DE ESTOQUE
select
    cast('Estoque' as varchar(100))as numero_nota,
    mo.data as data,
    cast('Estoque' as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(mo.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.descricao as varchar(50)) as nome_centro_custo_patrimonio,
    cast(sa.descricao as varchar(30)) as safra,
    cast((((select customedio from sp_customedio(mo.data,mo.cdproduto)) * mo.qtde) * -1) as decimal(15,2)) as valor_apropriado,
    cast(null as decimal(15,3)) as Desconto_Acrescimo,
    cast('' as varchar(250)) as complemento,
    cast('' as varchar(250)) as observacao
from
    movimentoestoque mo
    join produto pr on pr.cdproduto = mo.cdproduto
    join contagerencial cg on cg.cdcontagerencial = mo.cdcontagerencial
    join centrocusto cc on cc.cdcentrocusto = mo.cdcentrocusto
    left join safra sa on sa.cdsafra = mo.cdsafra
where
    mo.cdtipomovimentoestoque in (7,8,9,10) and
    mo.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)

UNION ALL

-- CONSULTA DE CUSTOS A PARTIR DA TELA DE DESPESAS
select
    cast(nt.numdocumento as varchar(100)) as numero_nota,
    nt.dtentradasaida as data,
    cast(pes.nome as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(ni.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(cc.descricao as varchar(50)) as nome_centro_custo_patrimonio,
    cast(sa.descricao as varchar(30)) as safra,
    cast((((ni.vrtotal / 100)*nia.percentual) * -1) as decimal(15,2)) as valor_apropriado,
    cast(nt.acrescimodesconto as decimal(15,3)) as Desconto_Acrescimo,
    cast(nt.complemento as varchar(250)) as complemento,
    cast(nt.observacao as varchar(250)) as observacao
from
    notaitem ni
    join nota nt on nt.cdnota = ni.cdnota
    join notaitemapro nia on nia.cdnotaitem = ni.cdnotaitem
    join produto pr on pr.cdproduto = ni.cdproduto
    join centrocusto cc on cc.cdcentrocusto = nia.cdcentrocusto
    join contagerencial cg on cg.cdcontagerencial = ni.cdcontagerencial
    join pessoa pes on pes.cdpessoa = nt.cdpessoa
    left join safra sa on sa.cdsafra = nia.cdsafra
where
    nt.tiponota = 'E' and
    ((nt.tipofiscal = 'N' and nt.cdnota not in (select re.cdnotavinculada from nota re where re.cdnotavinculada is not null)) or (nt.tipofiscal = 'I') )
    and ni.saidaimediata = '0'
    and ni.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)

UNION ALL

-- CONSULTA DE CUSTOS DE PATRIMÔNIO A PARTIR DA TELA DE DESPESAS
select
    cast(nt.numdocumento as varchar(100)) as numero_nota,
    nt.dtentradasaida as data,
    cast(pes.nome as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(ni.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(pat.descricao as varchar(50)) as nome_centro_custo_patrimonio,
    cast('' as varchar(30)) as safra,
    cast((ni.vrtotal * -1) as decimal(15,2)) as valor_apropriado,
    cast(nt.acrescimodesconto as decimal(15,3)) as Desconto_Acrescimo,
    cast(nt.complemento as varchar(250)) as complemento,
    cast(nt.observacao as varchar(250)) as observacao
from
    notaitem ni
    join nota nt on nt.cdnota = ni.cdnota
    join patrimonio pat on pat.cdpatrimonio = ni.cdpatrimonio
    join produto pr on pr.cdproduto = ni.cdproduto
    join contagerencial cg on cg.cdcontagerencial = ni.cdcontagerencial
    join pessoa pes on pes.cdpessoa = nt.cdpessoa
where
    nt.tiponota = 'E' and
    ((nt.tipofiscal = 'N' and nt.cdnota not in (select re.cdnotavinculada from nota re where re.cdnotavinculada is not null)) or (nt.tipofiscal = 'I') )
    and ni.saidaimediata = '0'
    and ni.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)

UNION ALL

-- CONSULTA DE CUSTOS E PATRIMÔNIO A PARTIR DAS SAÍDAS DE ESTOQUE
select
    cast('Estoque' as varchar(100))as numero_nota,
    mo.data as data,
    cast('Estoque' as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(mo.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(pat.descricao as varchar(50)) as nome_centro_custo_patrimonio,
    cast('' as varchar(30)) as safra,
    cast((((select customedio from sp_customedio(mo.data,mo.cdproduto)) * mo.qtde) * -1) as decimal(15,2)) as valor_apropriado,
    cast(null as decimal(15,3)) as Desconto_Acrescimo,
    cast('' as varchar(250)) as complemento,
    cast('' as varchar(250)) as observacao
from
    movimentoestoque mo
    join produto pr on pr.cdproduto = mo.cdproduto
    join contagerencial cg on cg.cdcontagerencial = mo.cdcontagerencial
    join patrimonio pat on pat.cdpatrimonio = mo.cdpatrimonio
where
    mo.cdtipomovimentoestoque in (7,8,9,10) and
    mo.cdcontagerencial in (select cdcontagerencial from contagerencial where fazparteatividade = 1)

order by 1
